{% extends "layouts/presentations/c_cpp_introduction.njk" %}

{% set title = "Programming in C" %}
{% set subtitle = "Introduction" %}

{% set language = "C" %}
{% set language_ = language | lower %}
{% set compiler = "clang" %}
{% set alt_compiler = "gcc" %}

{% block language_intro %}
<section>
  <h2>The C Programming Language</h2>

  <section>
  <h3>What is C?</h3>
  <ul>
    <li>General-purpose, procedural computer programming language</li>
    <li>C supports structured programming and recursion</li>
    <li>Static type system</li>
    <li>Creates highly efficient and performant machine code</li>
    <li class="fragment">Wikipedia: <a href="https://en.wikipedia.org/wiki/C_(programming_language)">C (programming language)</a></li>
    <li class="fragment"><a href="https://www.openhub.net/languages/compare?utf8=%E2%9C%93&measure=commits&language_name%5B%5D=c&language_name%5B%5D=cpp&language_name%5B%5D=golang&language_name%5B%5D=java&language_name%5B%5D=-1&language_name%5B%5D=rust&language_name%5B%5D=-1&commit=Update">Open Hub Comparison</a></li>
    <li class="fragment"><a href="https://www.tiobe.com/tiobe-index/">TIOBE Index</a></li>
  </ul>
  </section>

  <section>
    <h3>Application Areas</h3>
    <ul>
      <li>Operating systems (eg. Linux, Android)</li>
      <li>Implementation of programming languages (eg. cpython)</li>
      <li>High performance computations</li>
      <li>Application software (eg. GNOME Desktop, GIMP, ...)</li>
      <li>Embedded systems</li>
      <li>"Green Computing"</li>
    </ul>
  </section>

  <section>
    <h3>History</h3>
    <dl>
      <dt>1978</dt>
      <dd>Brian Kernighan and Dennis Ritchie (K&R) published<br />
        "<a href="https://archive.org/details/cprogramminglang00bria/mode/2up">The C Programming Language</a>"</dd>
      <dt>C99</dt>
      <dd>Still not supported by all common C compilers</dd>
      <dt>C11, C17</dt>
  </section>
</section>
{% endblock %}



{% include 'slides/closing.njk' %}
